using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Runtime.Serialization;

namespace WindowsApplication4
{
    public partial class Form1 : Form
    {
        private Class1 m_class1 = new Class1();
        private Class2 m_class2 = new Class2();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (fontDialog1.ShowDialog() == DialogResult.OK)
            {
                m_class1.font = fontDialog1.Font;
                m_class1.aString = m_class2.aString = "some text";

                textBox1.Text = m_class1.font.ToString();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            AppStateSerializer aser;

            aser = new AppStateSerializer(SerializeMode.XMLFile, "C:\\PreferencesWithFont");
            aser.SerializeObject("MyPreferences", m_class1);
            aser.PersistNow();

            aser = new AppStateSerializer(SerializeMode.XMLFile, "C:\\PreferencesWithoutFont");
            aser.SerializeObject("MyPreferences", m_class2);
            aser.PersistNow();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Class1 class1 = new Class1();
            Class2 class2 = new Class2();

            AppStateSerializer aser;

            aser = new AppStateSerializer(SerializeMode.XMLFile, "C:\\PreferencesWithFont");
            class1 = aser.DeserializeObject("MyPreferences") as Class1;

            aser = new AppStateSerializer(SerializeMode.XMLFile, "C:\\PreferencesWithoutFont");
            class2 = aser.DeserializeObject("MyPreferences") as Class2;

            label2.Text = "Class1:\n" + ((class1 == null) ? "Null" : ("A string: " + class1.aString + "\nthe font: " + class1.font.ToString()))
                + "\n\nClass2:\n" + ((class2 == null) ? "Null" : ("A string: " + class2.aString));
        }
    }
}